﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using System.Text.RegularExpressions;

namespace FileRename
{
    static class Constants
    {
        public const string PatternFilePath = @".\pattern.txt";
        public const int MaxLine = 10;
    }

    struct RenameFile
    {
        public string full;
        public string path;
        public string name;
    }

    class Program
    {
        static void Main(string[] args)
        {
            string[] files = null;
            while (true)
            {
                System.Console.WriteLine("Please drag-and-drop rename directory. And press Enter key.");
                string str = Console.ReadLine();
                str = str.Replace("\"", "");
                try
                {
                    files = Directory.GetFiles(str);
                }
                catch (IOException e)
                {
                    Console.WriteLine(e);
                    continue;
                }
                catch (ArgumentException e)
                {
                    Console.WriteLine(e);
                    continue;
                }
                break;
            }
            List<RenameFile> src = new List<RenameFile>();
            List<RenameFile> dst = new List<RenameFile>();
            bool err = false;
            while (true)
            {
                if (!File.Exists(Constants.PatternFilePath))
                {
                    Console.WriteLine($"Error:{Constants.PatternFilePath} NonExists.");
                    err = true;
                    break;
                }
                string readText = File.ReadAllText(Constants.PatternFilePath);
                string[] del = {"\r\n"};
                string[] text = readText.Split(del, StringSplitOptions.None);
                string[] mat = new string[Constants.MaxLine];
                string[] rep = new string[Constants.MaxLine];
                int i;
                for (i = 0; i < Constants.MaxLine; i++)
                {
                    mat[i] = text[1 + 4 * i];
                    rep[i] = text[3 + 4 * i];
                }
                int number = 0;
                int counter = 0;
                foreach (string strFile in files)
                {
                    RenameFile file;
                    file.full = strFile;
                    file.path = System.IO.Path.GetDirectoryName(strFile);
                    file.name = System.IO.Path.GetFileName(strFile);
                    src.Add(file);
                    for (i = 0; i < Constants.MaxLine; i++)
                    {
                        try
                        {
                            string rp = rep[i];
                            if (rp.IndexOf("$half") != -1)
                            {
                                if (Regex.IsMatch(file.name, mat[i]))
                                {
                                    string str = null;
                                    str = Regex.Replace(file.name, mat[i], "${half}");
                                    str = str.Replace("０", "0");
                                    str = str.Replace("１", "1");
                                    str = str.Replace("２", "2");
                                    str = str.Replace("３", "3");
                                    str = str.Replace("４", "4");
                                    str = str.Replace("５", "5");
                                    str = str.Replace("６", "6");
                                    str = str.Replace("７", "7");
                                    str = str.Replace("８", "8");
                                    str = str.Replace("９", "9");
                                    rp = rp.Replace("$half", $"{str}");
                                }
                            }
                            if (rp.IndexOf("$full") != -1)
                            {
                                if (Regex.IsMatch(file.name, mat[i]))
                                {
                                    string str = null;
                                    str = Regex.Replace(file.name, mat[i], "${full}");
                                    str = str.Replace("0", "０");
                                    str = str.Replace("1", "１");
                                    str = str.Replace("2", "２");
                                    str = str.Replace("3", "３");
                                    str = str.Replace("4", "４");
                                    str = str.Replace("5", "５");
                                    str = str.Replace("6", "６");
                                    str = str.Replace("7", "７");
                                    str = str.Replace("8", "８");
                                    str = str.Replace("9", "９");
                                    rp = rp.Replace("$full", $"{str}");
                                }
                            }
                            if (rp.IndexOf("$increment") != -1)
                            {
                                if (Regex.IsMatch(file.name, mat[i]))
                                {
                                    string str = null;
                                    str = Regex.Replace(file.name, mat[i], "${increment}");
                                    rp = rp.Replace("$increment", $"{int.Parse(str) + 1}");
                                }
                            }
                            if (rp.IndexOf("$decrement") != -1)
                            {
                                if (Regex.IsMatch(file.name, mat[i]))
                                {
                                    string str = null;
                                    str = Regex.Replace(file.name, mat[i], "${decrement}");
                                    rp = rp.Replace("$decrement", $"{int.Parse(str) - 1}");
                                }
                            }
                            if (rp.IndexOf("$lower") != -1)
                            {
                                if (Regex.IsMatch(file.name, mat[i]))
                                {
                                    string str = null;
                                    str = Regex.Replace(file.name, mat[i], "${lower}");
                                    str = str.ToLower();
                                    rp = rp.Replace("$lower", $"{str}");
                                }
                            }
                            if (rp.IndexOf("$upper") != -1)
                            {
                                if (Regex.IsMatch(file.name, mat[i]))
                                {
                                    string str = null;
                                    str = Regex.Replace(file.name, mat[i], "${upper}");
                                    str = str.ToUpper();
                                    rp = rp.Replace("$upper", $"{str}");
                                }
                            }
                            if (rp.IndexOf("$counter") != -1)
                            {
                                if (Regex.IsMatch(file.name, mat[i]))
                                {
                                    counter++;
                                    rp = rp.Replace("$counter", $"{counter}");
                                }
                            }
                            rp = rp.Replace("$number", $"{number}");
                            file.name = Regex.Replace(file.name, mat[i], rp);
                        }
                        catch (ArgumentException e)
                        {
                            Console.WriteLine(e);
                            err = true;
                            break;
                        }
                        catch (FormatException e)
                        {
                            Console.WriteLine(e);
                            err = true;
                            break;
                        }
                    }
                    if (err) break;
                    file.full = file.path + "\\" + file.name;
                    dst.Add(file);
                    number++;
                }
                for (i = 0; i < number; i++)
                {
                    if (err) break;
                    int n = 0, cnt = 0;
                    for (n = i + 1; n < number; n++)
                    {
                        if (!dst[i].name.Equals(dst[n].name)) continue;
                        cnt++;
                        RenameFile file;
                        file.path = dst[n].path;
                        int pos = dst[n].name.LastIndexOf('.');
                        if (pos == -1)
                        {
                            pos = dst[n].name.Length;
                        }
                        file.name = dst[n].name.Insert(pos, $"_{ cnt + 1 }");
                        file.full = file.path + file.name;
                        dst[n] = file;
                    }
                    Console.WriteLine(src[i].name + " => " + dst[i].name);
                }
                break;
            }
            int ch = 0;
            while (!err)
            {
                System.Console.WriteLine("\nRename?:y/n");
                ch = Console.ReadKey().KeyChar;
                if (ch == -1 | ch == 'y' | ch == 'n') break;
            }
            if (ch == 'y')
            {
                System.Console.WriteLine("\nRename start!");
                for(int i = 0; i < src.Count(); i++)
                {
                    File.Move(src[i].full, dst[i].full);
                }
                System.Console.WriteLine("Done.");
            }
            System.Console.WriteLine("\nPress Enter key for EXIT.");
            Console.ReadLine();
        }
    }
}
